Problem with oprofile on htc desire (bravo) - General Questions and Answers

Hi All.
I have been trying to get oprofile to work on an htc desire. I am running an unlocked phone purchased in the fall of 2010. I have built a custom kernel based on a snapshot of the dream team kernel (also from fall 2010). Android infrastructure layer is cyanogenmod 6.0.1. I know most of this is pretty old and I may be updating in the next few months, but for the most part this combination has been working for me so I plan to keep it until I find a compelling reason to change (broken feature I need that is fixed in a newer version etc).
My goal at this point is to profile a custom Linux application (no java involved, no NDK) we have developed for the phone. The application runs, but we need to improve performance of the 'system'. gprof has given us a lot of information but now we want the data you get from oprofile (valgrind gives us a pretty clean bill of health).
The process so far:
I have ported critical changes from the latest opcontrol that properly set file permissions etc.
Rebuilt kernel with profiling support turned on
fixed a set of bugs in cpuid processing. The Cortex-A8 CPU on the HTC desire reports a cpuid of 0x510f00f2 which was not supported in perf_event.c. FYI, arch/arm/kernel/setup.c has a very different mechanism for determining CPU type.
When I run opcontrol to setup and start oprofile(d), everything seems to be working. oprofilefs loads up properly and oprofiled is running but I get no samples.
I instrumented the kernel code (pmu.c etc) to see where things go wrong and found that there are no calls to pmu_device_probe which is the only code that sets up the pmu_devices array.
Sample output of instrumented code:
<6>[ 5.424957] hw perfevents: enabled with ARMv7 Cortex-A8 PMU driver, 5 counters available
<6>[ 160.288909] PMU: reserve_pmu: pmu_devices[device] is NULL. device - 0
<4>[ 160.289001] hw perfevents: unable to reserve pmu
At this point I am at a loss for where to look next. Does anyone know what code on the HTC Desire is supposed to call pmu_device_probe? I can only assume that some function is being told about potential hardware and calling probe functions to validate that the hardware is actually present and functioning. I do not know where to find this code on the desire (I come from a custom hardware world where we used ltib). Can anyone point me in the right direction? Has anyone gotten oprofile to work on the HTC Desire?

Problem with oprofile on htc desire (bravo) - Resolved
I have gotten oprofile to work on a 2.6.35 based teamdesire kernel. I have included the sed lines from my scripts and a set of files I added to arc/arm/kernel.
In essence, the stock kernel does not recognize the scorpion cpu and the init.bravo file does not create an arm-pmu device to manage the Qualcomm PMU hardware. In early March Qualcomm published a patch to the 2.6.38 kernel that added partial scorpion support. That patch plus other changes is included in the attached files and implemented in the sed script snippets I have included here.
When the scripts are done you can control builing oprofile support by using the .config.oprofile vs .config.no.oprofile kernel config files
Here is what I do to create a report. NOTE: In my architecture I do not use opimport. It seems that opreport in ubuntu 10.04 LTS can read the arm files just fine. NOTE2: In my system adb is disabled so I cannot use adb pull (or I would).
set up the profiler
opcontrol --setup --event=CPU_CYCLES:15000:::1:1
start the profiler
opcontrol --start
stop the profiler - saves samples to ram
opcontrol --stop
copy the samples to the sdcard
cd /sdcard
mkdir oprofileSamples
cp -r /data/oprofile /sdcard/oprofileSamples/oprofile
move the files to the build machine (It MUST be the machine on which the files where built)
turn off the phone and move the sdcard to a computer
cp -r /sdcard/oprofileSamples/oprofile /someplaceOnTheBuildMachine/oprofileSamples/oprofile
Open up the update file and extract the Android environment to a single area. There are instructions on the web telling you how to do this
now get your report
cd /someplaceOnTheBuildMachine/oprofileSamples/oprofile - In this directory you should have a samples subdir and you should have an abi file.
opreport --symbols -g --session-dir=. -R /LocationOnTheBuildMachineYouHaveYourOutput/android/debug/image
###############################
# changes to the Android SDK to support oprofile
sed -i 's/ARM V7 PMNC", "arm\/armv7", CPU_ARM_V7, 5 },/ARM V7 PMNC", "arm\/armv7", CPU_ARM_V7, 5 },\
{ "ARM V7 SCORPION", "arm\/scorpion", CPU_ARM_V7, 5 },\
{ "ARM V7 SCORPIONMP", "arm\/scorpionMP", CPU_ARM_V7, 5 },/g' $SYSTEM_PATH/external/oprofile/libop/op_cpu_type.c || exit
sed -i 's/if (mkdir(OP_DATA_DIR, 755)) {/if (mkdir(OP_DATA_DIR, 0755)) {/g' $SYSTEM_PATH/external/oprofile/opcontrol/opcontrol.cpp || exit
sed -i 's/if (mkdir(OP_DATA_DIR"\/samples", 644)) {/if (mkdir(OP_DATA_DIR"\/samples", 0755)) {/g' $SYSTEM_PATH/external/oprofile/opcontrol/opcontrol.cpp || exit
sed -i 's/if (mkdir(OP_DRIVER_BASE, 644)) {/if (mkdir(OP_DRIVER_BASE, 644)) {\
if( EEXIST != errno )\
{/g' $SYSTEM_PATH/external/oprofile/opcontrol/opcontrol.cpp || exit
sed -i 's/if (system("mount -t oprofilefs nodev "OP_DRIVER_BASE)) {/}\
\
system("umount "OP_DRIVER_BASE);\
if (system("mount -t oprofilefs nodev "OP_DRIVER_BASE)) {/g' $SYSTEM_PATH/external/oprofile/opcontrol/opcontrol.cpp || exit
echo "Got here"
sed -i 's/python2.4 -E/python2 -E/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/\[-s serial_number\] \[-r\]/\[-s serial_number\] \[-i indir\] \[-r\]/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/serial_number: the device being profiled"/serial_number: the device being profiled"\
print " -i indir: directory on the host from which to read sample data"/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/"x86_64"/"x86_64_IgnoreMe"/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/arch_path = ""/arch_path = ""\
\
raw_samples_dir = "raw_samples"/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/if sys.argv\[1\] == "-s":/if (sys.argv\[1\] == "-s"):/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/os.makedirs(output_dir)/os.makedirs( output_dir + "\/" + raw_samples_dir )/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/if sys.argv\[argv_next\] == "-r" :/if sys.argv\[argv_next\] == "-i" :\
input_dir = "%s" % sys.argv\[argv_next+1\]\
print " input dir = ", input_dir\
skip_pull = 1\
argv_next = argv_next + 2\
else:\
skip_pull = 0\
input_dir = ""\
\
if sys.argv\[argv_next\] == "-r" :/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/output_dir = sys.argv\[argv_next+1\]/output_dir = sys.argv\[argv_next+1\]\
argv_next = argv_next + 1/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/get the samples off the phone/\
if (skip_pull == 1) :\
result = os.system("cp -r %s\/* %s\/raw_samples"\
" > \/dev\/null 2>\&1" % (input_dir, output_dir))\
if result != 0:\
print "failure to copy %s\/* %s\/raw_samples\/." % (input_dir, output_dir)\
sys.exit(1)\
else:/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
sed -i 's/f -name \\\*all")/f -name \\\*\\\.\\\*\\\.\\\*")/g' $SYSTEM_PATH/external/oprofile/opimport_pull || exit
# end changes to the Android SDK support oprofile
###############################
###############################
# changes to the 2.6.35 team desire kernel support oprofile
sed -i 's,return "arm/armv7-ca9";,return "arm/armv7-ca9"; \
case ARM_PERF_PMU_ID_SCORPION: \
return "arm/scorpion"; \
case ARM_PERF_PMU_ID_SCORPIONMP: \
return "arm/scorpion-mp"; ,g' $KERNEL_PATH/arch/arm/oprofile/common.c || exit
sed -i 's/ARM_PERF_PMU_ID_CA9,/ARM_PERF_PMU_ID_CA9, \
ARM_PERF_PMU_ID_SCORPION,\
ARM_PERF_PMU_ID_SCORPIONMP,/g' $KERNEL_PATH/arch/arm/include/asm/perf_event.h || exit
cd $BUILD_OUTPUT_PATH || exit
svn export -N svn+ssh://[email protected]/common/svn/repos/infrastructure/vendor_src/android/$ANDROID_VERSION/$KERNEL_VENDOR-$MODEL-perf_event-patch >> /dev/null || exit
cd $KERNEL_PATH/arch/arm/kernel || exit
rm -f perf_event.*
tar -xf $BUILD_OUTPUT_PATH/$KERNEL_VENDOR-$MODEL-perf_event-patch || exit
cp $KERNEL_PATH/.config $KERNEL_PATH/.config.no.oprofile || exit
cp $KERNEL_PATH/.config $KERNEL_PATH/.config.oprofile || exit
sed -i 's/# CONFIG_PERF_EVENTS is not set/CONFIG_PERF_EVENTS=y/g' $KERNEL_PATH/.config.oprofile || exit
sed -i 's/# CONFIG_PERF_COUNTERS is not set/CONFIG_PERF_COUNTERS=y\
# CONFIG_DEBUG_PERF_USE_VMALLOC is not set/g' $KERNEL_PATH/.config.oprofile || exit
sed -i 's/# CONFIG_PROFILING is not set/CONFIG_PROFILING=y\
CONFIG_OPROFILE=y/g' $KERNEL_PATH/.config.oprofile || exit
sed -i 's/# CONFIG_HIGHMEM is not set/# CONFIG_HIGHMEM is not set\
CONFIG_HW_PERF_EVENTS=y/g' $KERNEL_PATH/.config.oprofile || exit
sed -i 's/CONFIG_HAVE_FUNCTION_TRACER=y/CONFIG_HAVE_FUNCTION_TRACER=y\
CONFIG_RING_BUFFER=y\
CONFIG_RING_BUFFER_ALLOW_SWAP=y/g' $KERNEL_PATH/.config.oprofile || exit
# end changes to support oprofile
###############################
Good luck and happy tuning.

Related

multi touch and JNI (native c code)

Here is what I had to do to get both JNI code and multi-touch events to live together.
NDK could not compile better than android-4 in default.properties
and SDK could not compile multi touch with less than android-5 in default.properties
Please let me know if anyone has found a cleaner way of doing this.
Code:
#
# remove installed apk
#
adb shell rm /data/app/org.giovino.*
#
# cross compile native code
#
cd ~/efb/src/umfd
make
ret=$?
echo "**** make returned "$ret
if [ $ret != 0 ]; then
echo failed
exit 1
fi
#
# compile JNI interface
#
cd ~/android/ndk
tail -1 apps/Try/project/default.properties
sed -i "s/android-5/android-4/g" apps/Try/project/default.properties
tail -1 apps/Try/project/default.properties
rm `find . -name libTry.so -print`
make APP=Try V=1
ret=$?
echo "**** make returned "$?
if [ $ret != 0 ]; then
echo failed
exit 1
fi
#
# compile apk android framework
#
cd apps/Try/project
tail -1 default.properties
sed -i "s/android-4/android-5/g" default.properties
tail -1 default.properties
ant debug
ret=$?
echo "**** ANT returned "$ret
if [ $ret != 0 ]; then
echo failed
exit 1
fi
#
# install apk application framework
#
adb install bin/Try-debug.apk
ret=$?
echo "**** adb returned "$ret

[TOOL] [Linux / OSX] elegos Splash Screen creator / flasher

I am simply reposting this from the mytouch thread by elegos, who is the creator of this script, I take no credit for this whatsoever.
Hello there!
This is a G1 / Magic tool to easily convert images in splash screen ones.
This tool is based upon ffmpeg and you need it installed on your system before proceeding (it will prompt you about the program missing in any case)
REQUIREMENTS
ffmpeg installed on your system
Code:
$ sudo apt-get install ffmpeg
a 320x480 image
a 320x480 device (i.e. G1 / Magic) with engineering SPL (S-OFF)
USAGE
Code:
./file [--help][-h]
Prints out how to use the script
Code:
./file your_image_file
Converts your image into a flashable splash screen, if you want the script will continue flashing the file directly.
NOTE: if you wish to make this script work with the Nexus One or any other device which doesn't share the same 320x480 resolution, just change these two variables:
Code:
size_check=307200
size_desc="320x480"
size_check is in bytes, size_desc is just a descriptive string.
I ASSUME NO RESPONSABILITY ABOUT THE USAGE OF THIS SCRIPT. USE IT "AS IS", LOOK AT THE OUTPUTS AND YOU'LL AVOID BRICKS!
Please, if you wish to redistribute this script, give the right credits and don't change the prog_header please (maybe link this discussion in a text file)!
Edit: I have added a already to use script for 320x480 devices only! Or you can make your own script using elegos's code. The script should already be marked as executable, if not then make executable:
http://www.mediafire.com/?wz83iff1eg3fv38
Usage for this script:
Code:
$ ./splash_creator fileimagename.whatever
Here the code is, just slap it in a text file, give it the executive permission (chmod +x filename) and use it!
Code:
#!/bin/bash
prog_header() {
echo "###############################"
echo "####### EleGoS's FFMPEG #######"
echo "# G1/Sapphire/MyTouch3G/Magic #"
echo "### Splash Screen converter ###"
echo "###############################"
echo "version 1.0"
echo ""
}
if [ "$1" == "--help" ] || [ "$1" == "-h" ]; then
prog_header
echo "Usage"
echo "$0 your_image_file"
exit 0
fi
warning() {
printf "\e[0;31m$1\e[0m \n"
}
check_ok() {
printf "\e[0;32m$1\e[0m \n"
}
ffmpeg_check=$(which ffmpeg)
size_check=307200
size_desc="320x480"
if [ "$ffmpeg_check" != "" ]; then
OUTPUT=$(echo "$1" | cut -d'.' -f1).raw565
clear
prog_header
ffmpeg -i $1 -f rawvideo -pix_fmt rgb565 $OUTPUT
clear
prog_header
FILESIZE=$(cat $OUTPUT | wc -c)
if [ $FILESIZE -eq $size_check ]; then
check_ok "$OUTPUT is ready to be flashed."
else
rm $OUTPUT
warning "$OUTPUT filesize mismatches! Wrong image size ($size_desc)? Aborted."
exit 0
fi
echo "In order to flash this image you have to plug your phone in fastboot mode."
read -p "Flash it now? (y/n) "
if [ "$REPLY" == "y" ] || [ "$REPLY" == "Y" ]; then
fastboot devices | grep -q "fastboot"
if [ $? -ne 0 ]; then
warning "The USB cable is not plugged, or the device is not in fastboot mode."
echo "To flash the splash screen, manually execute this command once in fastboot mode:"
echo "fastboot flash splash1 $OUTPUT"
exit 0
else
fastboot flash splash1 $OUTPUT
fi
else
echo "To flash the splash screen, execute this command once in fastboot mode:"
echo "fastboot flash splash1 $OUTPUT"
exit 0
fi
else
warning "ffmpeg not found! Please install it before running this script!\ni.e. (DEBIAN) apt-get install ffmpeg / (OSX) sudo port install ffmpeg"
fi
Edit:
elegos said:
- Open the terminal -> nano splash_creator
- copy / paste the code
- [CTRL]+O, then [ENTER]. [CTRL]+X
- chmod +x splash_creator
- Put the image you want as splash screen in a folder where the script is (it is actually in your home)
- Open terminal -> cd your/folder/here
- ./splash_creator your_image_here.whatever
Click to expand...
Click to collapse
Also feel free to post your splash screens here as well
Splash screens
So here's one that mjybarr made, and one I'm using right now, both very nice splash screens
Works like a dream! Thanks for providing this tut.

[GUIDE] Simple Java6 installation on Precise/Mint-Maya/Ubuntu 12.04 LTS

Hi all. I recently upgraded and was having a heck of a time trying to find out how to install java6 on the new Mint 13 since they pulled all the PPA's due to licensing restrictions. These are the steps I took to get it installed and working with Mint 13 Maya. This SHOULD work for other flavors of Precise.
Open terminal and in it type:
Code:
sudo apt-get purge openjdk*
ENTER
Code:
sudo apt-get purge *jre*
ENTER
Open up synaptics package manager and do a search for JRE or any other java related packages, make sure they are uninstalled.
NOW.
Once you are sure you've cleansed your system of any other java muck that might conflict you need to download this script.
https://github.com/flexiondotorg/oab-java6/blob/master/oab-java6.sh
Alternatively, open up a plain txt file and copy this code into it. The download link will more than likely be more up to date, but i'm putting this here for shiggles. Name it whatever you want.
Code:
#!/usr/bin/env bash
# Copyright (c) Martin Wimpress
# http://flexion.org/
# See the file "LICENSE" for the full license governing this code.
# References
# - https://github.com/rraptorr/sun-java6
# - http://ubuntuforums.org/showthread.php?t=1090731
# - http://irtfweb.ifa.hawaii.edu/~lockhart/gpg/gpg-cs.html
# Variables
VER="0.2.1"
function copyright_msg() {
local MODE=${1}
if [ "${MODE}" == "build_docs" ]; then
echo "OAB-Java6"
echo "========="
fi
echo `basename ${0}`" v${VER} - Create a local 'apt' repository for Ubuntu Java packages."
echo "Copyright (c) Martin Wimpress, http://flexion.org. MIT License"
echo
echo "By running this script to download Java you acknowledge that you have"
echo "read and accepted the terms of the Oracle end user license agreement."
echo
echo "* http://www.oracle.com/technetwork/java/javase/terms/license/"
echo
# Adjust the output if we are executing the script.
# It doesn't make sense to see this message here in the documentation.
if [ "${MODE}" != "build_docs" ]; then
echo "If you want to see what this is script is doing while it is running then execute"
echo "the following from another shell:"
echo
echo " tail -f `pwd`/`basename ${0}`.log"
echo
fi
}
function usage() {
local MODE=${1}
echo "Usage"
echo "-----"
echo "::"
echo
echo " sudo ${0}"
echo
echo "Optional parameters"
echo
echo "* ``-c`` : Remove pre-existing packages from ``/var/local/oab/deb``"
echo "* ``-s`` : Skip building if the packages already exist"
echo "* ``-h`` : This help"
echo
echo "How do I download and run this thing?"
echo "-------------------------------------"
echo "Like this."
echo "::"
echo
echo " cd ~/"
echo " wget https://github.com/flexiondotorg/oab-java6/raw/${VER}/`basename ${0}` -O `basename ${0}`"
echo " chmod +x `basename ${0}`"
echo " sudo ./`basename ${0}`"
echo
echo "If you are behind a proxy you may need to run using:"
echo "::"
echo
echo " sudo -i ./`basename ${0}`"
echo
# Adjust the output if we are building the docs.
if [ "${MODE}" == "build_docs" ]; then
echo "If you want to see what this is script is doing while it is running then execute"
echo "the following from another shell:"
echo "::"
echo
echo " tail -f ./`basename ${0}`.log"
echo
fi
echo "How it works"
echo "------------"
echo "This script is merely a wrapper for the most excellent Debian packaging"
echo "scripts prepared by Janusz Dziemidowicz."
echo
echo "* https://github.com/rraptorr/sun-java6"
echo
echo "The basic execution steps are:"
echo
echo "* Remove, my now disabled, Java PPA 'ppa:flexiondotorg/java'."
echo "* Install the tools required to build the Java packages."
echo "* Create download cache in ``/var/local/oab/pkg``."
echo "* Download the i586 and x64 Java install binaries from Oracle. Yes, both are required."
echo "* Clone the build scripts from https://github.com/rraptorr/sun-java6"
echo "* Build the Java packages applicable to your system."
echo "* Create local ``apt`` repository in ``/var/local/oab/deb`` for the newly built Java Packages."
echo "* Create a GnuPG signing key in ``/var/local/oab/gpg`` if none exists."
echo "* Sign the local ``apt`` repository using the local GnuPG signing key."
echo
echo "What gets installed?"
echo "--------------------"
echo "Nothing!"
echo
echo "This script will no longer try and directly install or upgrade any Java"
echo "packages, instead a local ``apt`` repository is created that hosts locally"
echo "built Java packages applicable to your system. It is up to you to install"
echo "or upgrade the Java packages you require using ``apt-get``, ``aptitude`` or"
echo "``synaptic``, etc. For example, once this script has been run you can simply"
echo "install the JRE by executing the following from a shell."
echo "::"
echo
echo " sudo apt-get install sun-java6-jre"
echo
echo "Or if you already have the *\"official\"* Ubuntu packages installed then you"
echo "can upgrade by executing the following from a shell."
echo "::"
echo
echo " sudo apt-get upgrade"
echo
echo "The local ``apt`` repository is just that, **local**. It is not accessible"
echo "remotely and `basename ${0}` will never enable that capability to ensure"
echo "compliance with Oracle's asinine license requirements."
echo
echo "Known Issues"
echo "------------"
echo
echo "* The Oracle download servers can be horribly slow. My script caches the downloads so you only need download each file once."
echo
echo "What is 'oab'?"
echo "--------------"
echo "Because, O.A.B! ;-)"
echo
# Only exit if we are not build docs.
if [ "${MODE}" != "build_docs" ]; then
exit 1
fi
}
function build_docs() {
copyright_msg build_docs > README.rst
# Add the usage instructions
usage build_docs >> README.rst
# Add the CHANGES
if [ -e CHANGES ]; then
cat CHANGES >> README.rst
fi
# Add the AUTHORS
if [ -e AUTHORS ]; then
cat AUTHORS >> README.rst
fi
# Add the TODO
if [ -e TODO ]; then
cat TODO >> README.rst
fi
# Add the LICENSE
if [ -e LICENSE ]; then
cat LICENSE >> README.rst
fi
echo "Documentation built."
exit 0
}
copyright_msg
# 'source' my common functions
if [ -r /tmp/common.sh ]; then
source /tmp/common.sh
if [ $? -ne 0 ]; then
echo "ERROR! Couldn't import common functions from /tmp/common.sh"
rm /tmp/common.sh 2>/dev/null
exit 1
else
update_thyself
fi
else
echo "Downloading common.sh"
wget --no-check-certificate -q "https://github.com/flexiondotorg/common/raw/master/common.sh" -O /tmp/common.sh
chmod 666 /tmp/common.sh
source /tmp/common.sh
if [ $? -ne 0 ]; then
echo "ERROR! Couldn't import common functions from /tmp/common.sh"
rm /tmp/common.sh 2>/dev/null
exit 1
fi
fi
# Check we are running on a supported system in the correct way.
check_root
check_sudo
check_ubuntu "all"
BUILD_KEY=""
BUILD_CLEAN=0
SKIP_REBUILD=""
# Parse the options
OPTSTRING=bchk:s
while getopts ${OPTSTRING} OPT
do
case ${OPT} in
b) build_docs;;
c) BUILD_CLEAN=1;;
h) usage;;
k) BUILD_KEY=${OPTARG};;
s) SKIP_REBUILD=1;;
*) usage;;
esac
done
shift "$(( $OPTIND - 1 ))"
# Remove my, now disabled, Java PPA.
if [ -e /etc/apt/sources.list.d/flexiondotorg-java-${LSB_CODE}.list ]; then
ncecho " [x] Removing ppa:flexiondotorg/java "
rm -v /etc/apt/sources.list.d/flexiondotorg-java-${LSB_CODE}.list* >> "$log" 2>&1
cecho success
fi
# Determine the build and runtime requirements.
BUILD_DEPS="build-essential debhelper defoma devscripts dpkg-dev git-core \
gnupg imvirt libasound2 libxi6 libxt6 libxtst6 rng-tools unixodbc unzip"
if [ "${LSB_ARCH}" == "amd64" ]; then
BUILD_DEPS="${BUILD_DEPS} lib32asound2 ia32-libs"
fi
# Install the Java build requirements
ncecho " [x] Installing Java build requirements "
apt-get install -y --no-install-recommends ${BUILD_DEPS} >> "$log" 2>&1 &
pid=$!;progress $pid
# Make sure the required dirs exist.
ncecho " [x] Making build directories "
mkdir -p /var/local/oab/{deb,gpg,pkg} >> "$log" 2>&1 &
pid=$!;progress $pid
# Set the permissions appropriately for 'gpg'
chown root:root /var/local/oab/gpg 2>/dev/null
chmod 0700 /var/local/oab/gpg 2>/dev/null
# Remove the 'src' directory everytime.
ncecho " [x] Removing clones of https://github.com/rraptorr/sun-java6 "
rm -rfv /var/local/oab/sun-java6* 2>/dev/null >> "$log" 2>&1
rm -rfv /var/local/oab/src 2>/dev/null >> "$log" 2>&1 &
pid=$!;progress $pid
# Clone the code
ncecho " [x] Cloning https://github.com/rraptorr/sun-java6 "
cd /var/local/oab/ >> "$log" 2>&1
git clone https://github.com/rraptorr/sun-java6 src >> "$log" 2>&1 &
pid=$!;progress $pid
# Get the last commit tag.
cd /var/local/oab/src >> "$log" 2>&1
TAG=`git tag -l | tail -n1`
# Checkout the tagged, stable, version.
ncecho " [x] Checking out ${TAG} "
git checkout ${TAG} >> "$log" 2>&1 &
pid=$!;progress $pid
# Cet the current Debian package version and package urgency
DEB_VERSION=`head -n1 /var/local/oab/src/debian/changelog | cut -d'(' -f2 | cut -d')' -f1 | cut -d'~' -f1`
DEB_URGENCY=`head -n1 /var/local/oab/src/debian/changelog | cut -d'=' -f2`
# Determine the currently supported Java version and update
JAVA_VER=`echo ${DEB_VERSION} | cut -d'.' -f1`
JAVA_UPD=`echo ${DEB_VERSION} | cut -d'.' -f2 | cut -d'-' -f1`
# Try and dynamic find the JDK downloads
ncecho " [x] Getting Java SE download page"
wget "http://www.oracle.com/technetwork/java/javase/downloads/index.html" -O /tmp/oab-index.html >> "$log" 2>&1 &
pid=$!;progress $pid
# See if the Java version is on the download frontpage, otherwise look for it in
# the previous releases page.
DOWNLOAD_INDEX=`grep -P -o "/technetwork/java/javase/downloads/jdk-${JAVA_VER}u${JAVA_UPD}-downloads-\d+\.html" /tmp/oab-index.html | uniq`
if [ -n "${DOWNLOAD_INDEX}" ]; then
ncecho " [x] Getting current release download page "
wget http://www.oracle.com/${DOWNLOAD_INDEX} -O /tmp/oab-download.html >> "$log" 2>&1 &
pid=$!;progress $pid
else
ncecho " [x] Getting previous releases download page "
wget http://www.oracle.com/technetwork/java/javasebusiness/downloads/java-archive-downloads-javase6-419409.html -O /tmp/oab-download.html >> "$log" 2>&1 &
pid=$!;progress $pid
fi
# Download the Oracle install packages.
for JAVA_BIN in jdk-${JAVA_VER}u${JAVA_UPD}-linux-i586.bin jdk-${JAVA_VER}u${JAVA_UPD}-linux-x64.bin
do
# Get the download URL and size
DOWNLOAD_URL=`grep ${JAVA_BIN} /tmp/oab-download.html | cut -d'{' -f2 | cut -d',' -f3 | cut -d'"' -f4`
DOWNLOAD_SIZE=`grep ${JAVA_BIN} /tmp/oab-download.html | cut -d'{' -f2 | cut -d',' -f2 | cut -d':' -f2 | sed 's/"//g'`
# Cookies required for download
COOKIES="oraclelicensejdk-${JAVA_VER}u${JAVA_UPD}-oth-JPR=accept-securebackup-cookie;gpw_e24=http://edelivery.oracle.com"
ncecho " [x] Downloading ${JAVA_BIN} : ${DOWNLOAD_SIZE} "
wget --no-check-certificate --header="Cookie: ${COOKIES}" -c "${DOWNLOAD_URL}" -O /var/local/oab/pkg/${JAVA_BIN} >> "$log" 2>&1 &
pid=$!;progress_loop $pid
ncecho " [x] Symlinking ${JAVA_BIN} "
ln -s /var/local/oab/pkg/${JAVA_BIN} /var/local/oab/src/${JAVA_BIN} >> "$log" 2>&1 &
pid=$!;progress_loop $pid
done
# Determine the new version
NEW_VERSION="${DEB_VERSION}~${LSB_CODE}1"
if [ -n "${SKIP_REBUILD}" -a -r "/var/local/oab/deb/sun-java${JAVA_VER}_${NEW_VERSION}_${LSB_ARCH}.changes" ]; then
echo " [!] Package exists, skipping build "
echo "All done!"
exit
fi
# Genereate a build message
BUILD_MESSAGE="Automated build for ${LSB_REL} using https://github.com/rraptorr/sun-java6"
# Change directory to the build directory
cd /var/local/oab/src
# Update the changelog
ncecho " [x] Updating the changelog "
dch --distribution ${LSB_CODE} --force-distribution --newversion ${NEW_VERSION} --force-bad-version --urgency=${DEB_URGENCY} "${BUILD_MESSAGE}" >> "$log" 2>&1 &
pid=$!;progress $pid
# Build the binary packages
ncecho " [x] Building the packages "
dpkg-buildpackage -b >> "$log" 2>&1 &
pid=$!;progress_can_fail $pid
if [ -e /var/local/oab/sun-java${JAVA_VER}_${NEW_VERSION}_${LSB_ARCH}.changes ]; then
# Remove any existing .deb files if the 'clean' option was selected.
if [ ${BUILD_CLEAN} -eq 1 ]; then
ncecho " [x] Removing existing .deb packages "
rm -fv /var/local/oab/deb/* >> "$log" 2>&1 &
pid=$!;progress $pid
fi
# Populate the 'apt' repository with .debs
ncecho " [x] Moving the packages "
mv -v /var/local/oab/sun-java${JAVA_VER}_${NEW_VERSION}_${LSB_ARCH}.changes /var/local/oab/deb/ >> "$log" 2>&1
mv -v /var/local/oab/*sun-java${JAVA_VER}-*_${NEW_VERSION}_*.deb /var/local/oab/deb/ >> "$log" 2>&1 &
pid=$!;progress $pid
else
error_msg "ERROR! Packages failed to build."
fi
# Create a temporary 'override' file, which may contain duplicates
echo "#Override" > /tmp/override
echo "#Package priority section" >> /tmp/override
for FILE in /var/local/oab/deb/*.deb
do
DEB_PACKAGE=`dpkg --info ${FILE} | grep Package | cut -d':' -f2`
DEB_SECTION=`dpkg --info ${FILE} | grep Section | cut -d'/' -f2`
echo "${DEB_PACKAGE} high ${DEB_SECTION}" >> /tmp/override
done
# Remove the duplicates from the overide file
uniq /tmp/override > /var/local/oab/deb/override
# Create the 'apt' Packages.gz
ncecho " [x] Creating Packages.gz file "
cd /var/local/oab/deb
dpkg-scanpackages . override 2>/dev/null > Packages
cat Packages | gzip -c9 > Packages.gz
rm /var/local/oab/deb/override 2>/dev/null
cecho success
# Create a 'Release' file
ncecho " [x] Creating Release file "
cd /var/local/oab/deb
echo "Origin: `hostname --fqdn`" > Release
echo "Label: Java" >> Release
echo "Suite: ${LSB_CODE}" >> Release
echo "Version: ${LSB_REL}" >> Release
echo "Codename: ${LSB_CODE}" >> Release
echo "Date: `date -R`" >> Release
echo "Architectures: ${LSB_ARCH}" >> Release
echo "Components: restricted" >> Release
echo "Description: Local Java Repository" >> Release
echo "MD5Sum:" >> Release
for PACKAGE in Packages*
do
printf ' '`md5sum ${PACKAGE} | cut -d' ' -f1`" %16d ${PACKAGE}\n" `wc --bytes ${PACKAGE} | cut -d' ' -f1` >> Release
done
cecho success
# Skip anything todo with automated key creation if this script is running in
# an OpenVZ container.
if [[ `imvirt` != "OpenVZ" ]]; then
# Do we need to create signing keys
if [ ! -e /var/local/oab/gpg/pubring.gpg ] && [ ! -e /var/local/oab/gpg/secring.gpg ] && [ ! -e /var/local/oab/gpg/trustdb.gpg ]; then
ncecho " [x] Create GnuPG configuration "
echo "Key-Type: DSA" > /var/local/oab/gpg-key.conf
echo "Key-Length: 1024" >> /var/local/oab/gpg-key.conf
echo "Subkey-Type: ELG-E" >> /var/local/oab/gpg-key.conf
echo "Subkey-Length: 2048" >> /var/local/oab/gpg-key.conf
echo "Name-Real: `hostname --fqdn`" >> /var/local/oab/gpg-key.conf
echo "Name-Email: [email protected]`hostname --fqdn`" >> /var/local/oab/gpg-key.conf
echo "Expire-Date: 0" >> /var/local/oab/gpg-key.conf
cecho success
# Stop the system 'rngd'.
/etc/init.d/rng-tools stop >> "$log" 2>&1
ncecho " [x] Start generating entropy "
rngd -r /dev/urandom -p /tmp/rngd.pid >> "$log" 2>&1 &
pid=$!;progress $pid
ncecho " [x] Creating signing key "
gpg --homedir /var/local/oab/gpg --batch --gen-key /var/local/oab/gpg-key.conf >> "$log" 2>&1 &
pid=$!;progress $pid
ncecho " [x] Stop generating entropy "
kill -9 `cat /tmp/rngd.pid` >> "$log" 2>&1 &
pid=$!;progress $pid
rm /tmp/rngd.pid 2>/dev/null
# Start the system 'rngd'.
/etc/init.d/rng-tools start >> "$log" 2>&1
fi
fi
# Do we have signing keys, if so use them.
if [ -e /var/local/oab/gpg/pubring.gpg ] && [ -e /var/local/oab/gpg/secring.gpg ] && [ -e /var/local/oab/gpg/trustdb.gpg ]; then
# Sign the Release
ncecho " [x] Signing the 'Release' file "
rm /var/local/oab/deb/Release.gpg 2>/dev/null
gpg --homedir /var/local/oab/gpg --armor --detach-sign --output /var/local/oab/deb/Release.gpg /var/local/oab/deb/Release >> "$log" 2>&1 &
pid=$!;progress $pid
# Export public signing key
ncecho " [x] Exporting public key "
gpg --homedir /var/local/oab/gpg --export -a "`hostname --fqdn`" > /var/local/oab/deb/pubkey.asc
cecho success
# Add the public signing key
ncecho " [x] Adding public key "
apt-key add /var/local/oab/deb/pubkey.asc >> "$log" 2>&1 &
pid=$!;progress $pid
fi
# Update apt cache
echo "deb file:///var/local/oab/deb / #Sun Java6 - https://github.com/flexiondotorg/oab-java6" > /etc/apt/sources.list.d/oab.list
apt_update
echo "All done!"
Whether you download the script, or if you make your own text file, you need to enable the executing permission bit. So change your directory to wherever you saved the script and then in terminal type this and hit enter:
Code:
chmod +x ./whatever_the_script_is_named
Then in the terminal run the script with:
Code:
sudo ./oab-java6.sh
or
Code:
sudo ./whatever_you_named_this_script
What this does, is build packages for your system and places them in a local repository for apt-get to install. This bypasses java anal retentive licensing bullsquash. So, now we need to install it with:
Code:
sudo apt-get install sun-java6-jre
ENTER
Wait for it to finish and ensure your version is correcty by typing:
Code:
java -version
ENTER
You should get an output similar to:
Code:
[email protected] ~ $ java -version
java version "1.6.0_32"
Java(TM) SE Runtime Environment (build 1.6.0_32-b05)
Java HotSpot(TM) 64-Bit Server VM (build 20.7-b02, mixed mode)
[email protected] ~ $
Hope this helps someone and I hope this is in the correct forum!
Im going to be editing this as it seems there's really no reason to purge OpenJDK from the system, I think. I'm also having some compiling errors so once I get those nailed down, I'll probably just write a guide detailing the entire setup/config for 12.04.
It works !!!
Thanks for posting this, this worked well.
Only thing I would like to add is that if someone is looking to add the java plugin to firefox, then they would need to manually create a link in the firefox plugins directory:
$ cd /usr/lib/firefox-addons/plugins
$ sudo ln -s /usr/lib/jvm/java-6-sun-1.6.0.32/jre/lib/i386/libnpjp2.so
$ ls -lrt
total 0
lrwxrwxrwx 1 root root 57 2011-12-20 11:05 libnpjp2.so -> /usr/lib/jvm/java-6-sun-1.6.0.26/jre/lib/i386/libnpjp2.so
Restart firefox, it should work now.
Keep It All!
Hi folks
I'll just chuck an alternative method in for good measure and one that I successfully on ubuntu versions 11.10 , 12.04 and 12.10 as well every other debian derivative
Add these three repositories like so.
Code:
sudo add-apt-repository "deb http://archive.ubuntu.com/ubuntu hardy main multiverse"
sudo add-apt-repository "deb http://archive.ubuntu.com/ubuntu hardy-updates main multiverse"
sudo add-apt-repository "deb http://archive.canonical.com/ lucid partner"
sudo apt-get update
You can then install both version 5 and 6 of the sun jdk and leave any existing installs in tact.
For extra beans you can install openjdk-7-jdk without any adverse effects - I ran the following
Code:
sudo apt-get install sun-java6-jdk
sudo apt-get install sun-java5-jdk
sudo apt-get install openjdk-7-jdk
After that you can use /bin/update-aleternatives to manage which version to use. for example
Code:
sudo update-alternatives --config java
This gives me the following versions of java to use as my "java" command
Code:
There are 4 choices for the alternative java (providing /usr/bin/java).
Selection Path Priority Status
------------------------------------------------------------
0 /usr/lib/jvm/java-6-openjdk-amd64/jre/bin/java 1061 auto mode
1 /usr/lib/jvm/java-1.5.0-sun/jre/bin/java 53 manual mode
2 /usr/lib/jvm/java-6-openjdk-amd64/jre/bin/java 1061 manual mode
3 /usr/lib/jvm/java-6-sun/jre/bin/java 63 manual mode
* 4 /usr/lib/jvm/java-7-openjdk-amd64/jre/bin/java 1051 manual mode
Press enter to keep the current choice[*], or type selection number:
Pick which version you need/want to use and away you go, you can switch most of the applications on the java platform painlessy with this method this includes javaws, javah , javac , jdb. if you're working with android only javac and java is required however, so do the same for javac
Code:
sudo update-alternatives --config javac
see "/etc/alternatives" for a list of application which may have alternatives and obviously the man and help has full details and how you can manage applications I also think there is a Kde, Gnome front end for it as well.
I got the repo info for sun jdk 5/6 from google's Android AOSP build instructions
Ta
thank you!
Thank you! I've tried many other scripts and sites without success. I should have started with xda for this. Thank you again.
Script location update.
Just an FYI, the location of the script has change, as the author has also included it to install Java 7.
The new location is https github.com/flexiondotorg/oab-java6
NOTE: the script pasted in the OP no longer works as making the .deb file will fail unless you download the jce_poclicy-6.zip. (which the script deletes the next time you run it)
EDIT: I also tested this on Ubuntu 10.04, and it is working for both JRE and JDK
Can you confirm whether this method still works? I have followed the directions here and on the source.android.com website to install sun-java6-sdk and my ubuntu 12.04 is not finding the install package. When I run the update script the hardy repository is giving me 404 errors. Have things changed significantly since this was posted?
trevd said:
Hi folks
I'll just chuck an alternative method in for good measure and one that I successfully on ubuntu versions 11.10 , 12.04 and 12.10 as well every other debian derivative
Add these three repositories like so.
Code:
sudo add-apt-repository "deb http://archive.ubuntu.com/ubuntu hardy main multiverse"
sudo add-apt-repository "deb http://archive.ubuntu.com/ubuntu hardy-updates main multiverse"
sudo add-apt-repository "deb http://archive.canonical.com/ lucid partner"
sudo apt-get update
You can then install both version 5 and 6 of the sun jdk and leave any existing installs in tact.
For extra beans you can install openjdk-7-jdk without any adverse effects - I ran the following
Code:
sudo apt-get install sun-java6-jdk
sudo apt-get install sun-java5-jdk
sudo apt-get install openjdk-7-jdk
After that you can use /bin/update-aleternatives to manage which version to use. for example
Code:
sudo update-alternatives --config java
This gives me the following versions of java to use as my "java" command
Code:
There are 4 choices for the alternative java (providing /usr/bin/java).
Selection Path Priority Status
------------------------------------------------------------
0 /usr/lib/jvm/java-6-openjdk-amd64/jre/bin/java 1061 auto mode
1 /usr/lib/jvm/java-1.5.0-sun/jre/bin/java 53 manual mode
2 /usr/lib/jvm/java-6-openjdk-amd64/jre/bin/java 1061 manual mode
3 /usr/lib/jvm/java-6-sun/jre/bin/java 63 manual mode
* 4 /usr/lib/jvm/java-7-openjdk-amd64/jre/bin/java 1051 manual mode
Press enter to keep the current choice[*], or type selection number:
Pick which version you need/want to use and away you go, you can switch most of the applications on the java platform painlessy with this method this includes javaws, javah , javac , jdb. if you're working with android only javac and java is required however, so do the same for javac
Code:
sudo update-alternatives --config javac
see "/etc/alternatives" for a list of application which may have alternatives and obviously the man and help has full details and how you can manage applications I also think there is a Kde, Gnome front end for it as well.
I got the repo info for sun jdk 5/6 from google's Android AOSP build instructions
Ta
Click to expand...
Click to collapse
jaxsin said:
Can you confirm whether this method still works? I have followed the directions here and on the source.android.com website to install sun-java6-sdk and my ubuntu 12.04 is not finding the install package. When I run the update script the hardy repository is giving me 404 errors. Have things changed significantly since this was posted?
Click to expand...
Click to collapse
Hi There,
Yes I believe they have as I noticed the same thing just recently, Although I will be looking a bit deeper when I installl 13.10. You are better off using the webupd8 team oracle java installer now I think, additionally AOSP master branch doesn't build anymore with the sun java version.
trevd said:
Hi There,
Yes I believe they have as I noticed the same thing just recently, Although I will be looking a bit deeper when I installl 13.10. You are better off using the webupd8 team oracle java installer now I think, additionally AOSP master branch doesn't build anymore with the sun java version.
Click to expand...
Click to collapse
which java version is worth using then? Openjdk v6, 7 or 8? I am considering trying to build CM 10.2 and I see they recommend to use Openjdk. Any thoughts?
jaxsin said:
which java version is worth using then? Openjdk v6, 7 or 8? I am considering trying to build CM 10.2 and I see they recommend to use Openjdk. Any thoughts?
Click to expand...
Click to collapse
I haven't use the openJDK offerings so I couldn't recommend one, I'm afraid. However, I did a little moreresearch google search into Hardy's disappearance. it turns out Hardy Heron 8.04 was EOL'd in May [ Announcement on the Ubuntu Fridge ]
All is not lost though as the hardy repos have just been moved to http://old-releases.ubuntu.com/ .
so if If you really need the sun java6 jdk or even sun's java5 jdk you can add these lines to you /etc/apt/sources.list and they should install fine.
Code:
deb http://archive.canonical.com/ lucid partner
deb http://old-releases.ubuntu.com/ubuntu hardy-updates main multiverse
deb http://old-releases.ubuntu.com/ubuntu hardy main multiverse
However as previously mentioned the sun java6 jdk no longer builds the master branch of the AOSP but at least the correct links are there for future reference. Currently Webupd8 team have the latest (now) oracle's version of the java6 jdk which is what I currently use for building. So to install oracle's versions of the jdk, do the following
Code:
sudo add-apt-repository --yes ppa:webupd8team/java
sudo apt-get install oracle-java8-installer
sudo apt-get install oracle-java7-installer
sudo apt-get install oracle-java6-installer
Obviously you can use update-alternatives to switch between them as/if required and make's the question of which is worth using/installing kinda moot ... Install them ALL! I haz every java. lol
Thanks
trevd :good:

Rooting the webOS TV

pivotce.com informs that instructions have been published on gaining root access to a webOS TV. This is much harder than on the old phones and tablets. When this was done on legacy webOS, there was a wave of enhancements and tweaks made available to phone users from webOS Internals and other developers.
The instructions can be found on the Russian webOS forums here: webos-forums.ru/topic4650.html (English Translation via Google).
As the thread itself notes, this creates the possibility of fiddling with your TV in a way that may turn it into a large, thin brick and will almost certainly invalidate your warranty. The general user should stay well clear of this.
pivotCE published this for information only and recommend leaving investigations to those who know what they are doing or who can afford to wreck expensive television sets. We will watch to see if anything interesting emerges from this development.
+
Detailed analysis of the root access method described above:
forums.webosnation.com/lg-webos-tv/331754-pivotce-seems-webos-tv-has-been-rooted.html#post3450911
Hello!
I'm from webos-forums.ru. I've root on TV for a while and can help you with translation or testing on LG webOS 1.4.
rooting
I could use your help rooting my lg 65uf6450-ua if you would. Thank you
Root webOS
Hodizzal said:
I could use your help rooting my lg 65uf6450-ua if you would. Thank you
Click to expand...
Click to collapse
1. You need to install Developer Mode App and export private ssh-key with CLI (webostv.developer.lge.com/develop/app-test)
2. Convert private ssh-key with puttygen [import key <your private ssh-key>, then save private key]
3. Download exploit (zalil.su/6937580), then connect with TV User: prisoner, [<ip-tv>:9922] + private-key with WinSCP (or other SCP-client), upload to /media/developer on TV and rename it to root.
on linux
Code:
ssh -i <your private ssh-key> [email protected]<ip-tv> -p 9922 "/bin/sh -i"
4.
Code:
chmod +x root
Code:
./root
5. After try install any app from market go to LG App Store and try to install any app.
6. if third stage ok. the insert password 1111 as said.
7.
Code:
busybox chroot /proc/1/root
Code:
[email protected]tTV:/# id
Code:
uid=0(root) gid=0(root)........
I personally use Linux Subsystem on Windows 10 for all of this.
To install .ipk app:
Code:
ApplicationInstallerUtility -c install -p /tmp/<any-name>.ipk -u 0 -l /media/developer -d
Info about your linux kernel and TV firmware:
Code:
luna-send -n 1 -f luna://com.palm.systemservice/osInfo/query '{ "subscribe": false }'
Launch app:
Code:
luna-send -n 1 -f luna://com.webos.applicationManager/launch '{"id": "netflix"}'
All apps ID you can find with
Code:
luna-send -n 1 "palm://com.palm.applicationManager/listLaunchPoints" "{}"
or at a folder /media/cryptofs/apps/usr/palm/applications/<App ID>/appinfo.json
For permanent root access through telnet:
1)
Code:
[email protected]:/# mkdir -p /media/cryptofs/root/etc
2)
Code:
[email protected]:/# cp -r /etc/* /media/cryptofs/root/etc
3)
Code:
[email protected]:/# mount -o bind /media/cryptofs/root/etc /etc
4)
Code:
[email protected]:/# passwd root
Enter any new root password
5)
Code:
cp /media/cryptofs/apps/usr/palm/services/com.palmdts.devmode.service/start-devmode.sh /tmp/start-devmode.sh
6) Download with WinSCP start-devmode.sh and edit it locally.
You need to add at the beginning
Code:
mount -o bind /media/cryptofs/root/etc /etc
telnetd -l /sbin/sulogin &
Plus you can add the line to launch any App at start, e.g:
Code:
luna-send -n 1 -f luna://com.webos.applicationManager/launch '{"id": "netflix", "params":{}}'
And comment Dev Mode online check.
Here it's mine start-devmode.sh. It's for webOS 1.4. It can be different for other webOS versions:
Code:
#!/bin/sh
mount -o bind /media/cryptofs/root/etc /etc
telnetd -l /sbin/sulogin &
#luna-send -n 1 -f luna://com.webos.applicationManager/launch '{"id": "netflix", "params":{}}'
# FIXME: disable this to turn off script echo
set -x
# FIXME: disable this to stop script from bailing on error
# set -e
# TODO: Check upstart daemon/process tracking (do we need to change /etc/init/devmode.conf? start sshd as daemon?)
# set devmode ssh port here
SSH_PORT="9922"
# set arch:
ARCH="armv71"
grep -qs "qemux86" /etc/hostname && ARCH="i686"
# set directories
OPT_DEVMODE="/opt/devmode"
OPT_SSH="/opt/openssh"
DEVELOPER_HOME="/media/developer"
DEVMODE_SERVICE_DIR="/media/cryptofs/apps/usr/palm/services/com.palmdts.devmode.service"
CRYPTO_SSH="$DEVMODE_SERVICE_DIR/binaries-${ARCH}/opt/openssh"
CRYPTO_OPT="$DEVMODE_SERVICE_DIR/binaries-${ARCH}/opt"
if [ -s ${DEVMODE_SERVICE_DIR}/jail_app.conf ] ; then
mv ${DEVMODE_SERVICE_DIR}/jail_app.conf ${DEVELOPER_HOME}
mv ${DEVMODE_SERVICE_DIR}/jail_app.conf.sig ${DEVELOPER_HOME}
fi
if [ -r ${DEVMODE_SERVICE_DIR}/sessionToken ] ; then
mv -f ${DEVMODE_SERVICE_DIR}/sessionToken /var/luna/preferences/devmode_enabled
fi
# Make sure the ssh binaries are executable (in service directory)
if [ ! -x "${CRYPTO_SSH}/sbin/sshd" ] ; then
chmod ugo+x ${CRYPTO_SSH}/sbin/sshd ${CRYPTO_SSH}/bin/ssh* ${CRYPTO_SSH}/bin/scp* || true
chmod ugo+x ${CRYPTO_SSH}/bin/sftp ${CRYPTO_SSH}/lib/openssh/* || true
chmod ugo+x ${CRYPTO_OPT}/devmode/usr/bin/* || true
fi
# TODO: (later) Look for "re-init" flag to re-generate ssh key if requested by app (via devkey service)
# com.palm.service.devmode could have "resetKey" method to erase /var/lib/devmode/ssh/webos_rsa
# Kind of dangerous though, since new key will need to be fetched on the desktop (after reboot)...
# We could just require a hard-reset of the TV which should blow away /var/lib/devmode/ssh/...
# Initialize the developer (client) SSH key pair, if it doesn't already exist
if [ ! -e /var/lib/devmode/ssh/webos_rsa ] ; then
mkdir -p /var/lib/devmode/ssh
chmod 0700 /var/lib/devmode/ssh
# get FIRST six (UPPER-CASE, hex) characters of 40-char nduid from nyx-cmd
# NOTE: This MUST match passphrase as displayed in devmode app (main.js)!
# PASSPHRASE="`/usr/bin/nyx-cmd DeviceInfo query nduid | head -c 6 | tr 'a-z' 'A-Z'`"
# PASSPHRASE="`/usr/bin/nyx-cmd DeviceInfo query nduid | tail -n1 | head -c 6 | tr 'a-z' 'A-Z'`"
PASSPHRASE="`tail /var/lib/secretagent/nduid -c 40 | head -c 6 | tr 'a-z' 'A-Z'`"
${CRYPTO_SSH}/bin/ssh-keygen -t rsa -C "[email protected]" -N "${PASSPHRASE}" -f /var/lib/devmode/ssh/webos_rsa
# copy ssh key to /var/luna/preferences so the devmode service's KeyServer can read it and serve to ares-webos-cli tools
cp -f /var/lib/devmode/ssh/webos_rsa /var/luna/preferences/webos_rsa
chmod 0644 /var/luna/preferences/webos_rsa
# if we generated a new ssh key, make sure we re-create the authorized_keys file
rm -f ${DEVELOPER_HOME}/.ssh/authorized_keys
fi
# Make sure the /media/developer (and log) directories exists (as sam.conf erases it when devmode is off):
mkdir -p ${DEVELOPER_HOME}/log
chmod 777 ${DEVELOPER_HOME} ${DEVELOPER_HOME}/log
# Install the SSH key into the authorized_keys file (if it doesn't already exist)
if [ ! -e ${DEVELOPER_HOME}/.ssh/authorized_keys ] ; then
mkdir -p ${DEVELOPER_HOME}/.ssh
cp -f /var/lib/devmode/ssh/webos_rsa.pub ${DEVELOPER_HOME}/.ssh/authorized_keys || true
# NOTE: authorized_keys MUST be world-readable else sshd can't read it inside the devmode jail
# To keep sshd from complaining about that, we launch sshd with -o "StrictModes no" (below).
chmod 755 ${DEVELOPER_HOME}/.ssh
chmod 644 ${DEVELOPER_HOME}/.ssh/authorized_keys
chown -R developer:developer ${DEVELOPER_HOME}/.ssh
fi
# FIXME: Can we move this to /var/run/devmode/sshd ?
# Create PrivSep dir
mkdir -p /var/run/sshd
chmod 0755 /var/run/sshd
# Create directory for host keys (rather than /opt/openssh/etc/ssh/)
HOST_KEY_DIR="/var/lib/devmode/sshd"
if [ ! -d "${HOST_KEY_DIR}" ] ; then
mkdir -p ${HOST_KEY_DIR}
chmod 0700 ${HOST_KEY_DIR}
fi
# Create initial keys if necessary
if [ ! -f ${HOST_KEY_DIR}/ssh_host_rsa_key ]; then
echo " generating ssh RSA key..."
${CRYPTO_SSH}/bin/ssh-keygen -q -f ${HOST_KEY_DIR}/ssh_host_rsa_key -N '' -t rsa
fi
if [ ! -f ${HOST_KEY_DIR}/ssh_host_ecdsa_key ]; then
echo " generating ssh ECDSA key..."
${CRYPTO_SSH}/bin/ssh-keygen -q -f ${HOST_KEY_DIR}/ssh_host_ecdsa_key -N '' -t ecdsa
fi
if [ ! -f ${HOST_KEY_DIR}/ssh_host_dsa_key ]; then
echo " generating ssh DSA key..."
${CRYPTO_SSH}/bin/ssh-keygen -q -f ${HOST_KEY_DIR}/ssh_host_dsa_key -N '' -t dsa
fi
# Check config
# NOTE: This should only be enabled for testing
#${CRYPTO_SSH}/sbin/sshd -f ${CRYPTO_SSH}/etc/ssh/sshd_config -h ${HOST_KEY_DIR}/ssh_host_rsa_key -t
# Set jailer command
DEVMODE_JAIL="/usr/bin/jailer -t native_devmode -i com.palm.devmode.openssh -p ${DEVELOPER_HOME}/ -s /bin/sh"
#DEVMODE_JAIL="echo"
# Add for debugging, but this will cause sshd to exit after the first ssh login:
# -ddd -e
# Make environment file for openssh
DEVMODE_JAIL_CONF="/etc/jail_native_devmode.conf"
DEVMODE_OPENSSH_ENV="${DEVELOPER_HOME}/.ssh/environment"
if [ -f ${DEVMODE_JAIL_CONF} ]; then
echo " generating environment file from jail_native_devmode.conf..."
find ${DEVMODE_JAIL_CONF} | xargs awk '/setenv/{printf "%s=%sn", $2,$3}' > ${DEVMODE_OPENSSH_ENV}
${DEVMODE_JAIL} /usr/bin/env >> ${DEVMODE_OPENSSH_ENV}
fi
# Set path for devmode
if [ -f ${DEVMODE_OPENSSH_ENV} ]; then
echo "PATH=${PATH}:${OPT_DEVMODE}/usr/bin" >> ${DEVMODE_OPENSSH_ENV}
fi
sleep 5;
for interface in $(ls /sys/class/net/ | grep -v -e lo -e sit);
do
if [ -r /sys/class/net/$interface/carrier ] ; then
if [[ $(cat /sys/class/net/$interface/carrier) == 1 ]]; then OnLine=1; fi
fi
done
#if [ $OnLine ]; then
# sessionToken=$(cat /var/luna/preferences/devmode_enabled);
# checkSession=$(curl --max-time 3 -s https://developer.lge.com/secure/CheckDevModeSession.dev?sessionToken=$sessionToken);
# if [ "$checkSession" != "" ] ; then
# result=$(node -pe 'JSON.parse(process.argv[1]).result' "$checkSession");
# if [ "$result" == "success" ] ; then
rm -rf /var/luna/preferences/dc*;
# # create devSessionTime file to remain session time in devmode app
# remainTime=$(node -pe 'JSON.parse(process.argv[1]).errorMsg' "$checkSession");
# resultValidTimeCheck=$(echo "${remainTime}" | egrep "^([0-9]{1,4}(:[0-5][0-9]){2})$");
# if [ "$resultValidTimeCheck" != "" ] ; then
echo '900:00:00' > ${DEVMODE_SERVICE_DIR}/devSessionTime;
chgrp 5000 ${DEVMODE_SERVICE_DIR}/devSessionTime;
chmod 664 ${DEVMODE_SERVICE_DIR}/devSessionTime;
# fi
# elif [ "$result" == "fail" ] ; then
# rm -rf /var/luna/preferences/devmode_enabled;
# rm -rf /var/luna/preferences/dc*;
# if [ -e ${DEVMODE_SERVICE_DIR}/devSessionTime ] ; then
# rm ${DEVMODE_SERVICE_DIR}/devSessionTime;
# fi
# fi
# fi
#fi
# Cache clear function added (except Local storage)
if [ -e ${DEVMODE_SERVICE_DIR}/devCacheClear ] ; then
rm -rf `ls | find /var/lib/webappmanager*/* -name "Local Storage" -o -name "localstorage" -prune -o -print`;
rm ${DEVMODE_SERVICE_DIR}/devCacheClear;
fi
# Launch sshd
${DEVMODE_JAIL} ${OPT_SSH}/sbin/sshd
-o StrictModes=no
-f ${OPT_SSH}/etc/ssh/sshd_config
-h ${HOST_KEY_DIR}/ssh_host_rsa_key
-o PasswordAuthentication=no -o PermitRootLogin=no -o PermitUserEnvironment=yes
-D -p ${SSH_PORT}
7) Upload new start-devmode.sh and rewrite the old one
Code:
cp /tmp/start-devmode.sh /media/cryptofs/apps/usr/palm/services/com.palmdts.devmode.service/start-devmode.sh
8) Restart TV.
Connect with telnet and type previously entered password.
Code:
telnet <ip-tv>
Trying <ip-tv>...
Connected to <ip-tv>].
Escape character is '^]'.
webOS TV 1.4.0 LGSmartTV
Give root password for system maintenance
(or type Control-D for normal startup):
Entering System Maintenance Mode
[email protected]:/#
Does it work on WebOS 3.5 devices?
medi01 said:
Does it work on WebOS 3.5 devices?
Click to expand...
Click to collapse
Positive.
is it possible to install webOS 3.0 on an 65EF9500 that currently has WebOS 2.0 via the USB upgrade method?
enkrypt3d said:
is it possible to install webOS 3.0 on an 65EF9500 that currently has WebOS 2.0 via the USB upgrade method?
Click to expand...
Click to collapse
No
Is there any method to get 3.0 installed over 1.4 I have a 49ub8500-ua
syconu said:
Is there any method to get 3.0 installed over 1.4 I have a 49ub8500-ua
Click to expand...
Click to collapse
No
Is there anything hack related that I can do with this to and can is support a new air mouse with a dongle
Ok, so I get run the root app and first ,second , and third stage all are good. then it says try get root password is 1111. But the terminal keeps freezing after that happens. A couple times my tv rebooted too. I cant figure out what i could have messed up. ANyone with any experience using this method have any legit information?
steven817817 said:
Ok, so I get run the root app and first ,second , and third stage all are good. then it says try get root password is 1111. But the terminal keeps freezing after that happens. A couple times my tv rebooted too. I cant figure out what i could have messed up. ANyone with any experience using this method have any legit information?
Click to expand...
Click to collapse
Try to delete all 'cache' files from exploit at /media/developer. It doesn't wotk twice as far as I concerned
Is there anyway I can root my 1.4.0 and if so what r the benefits of the root? Can I install Android or kodi? What's the point
teffd said:
Try to delete all 'cache' files from exploit at /media/developer. It doesn't wotk twice as far as I concerned
Click to expand...
Click to collapse
I tried it stil seems to finish step 3 then says enter 1111. But this is where it freezes up and does not get any further.
Is this still working on 3.6? I'm stuck at try to install any app from market.
Mazda77 said:
Positive.
Click to expand...
Click to collapse
Which TV and firmware version?
Is this possible with UJ63 serie?
Hi, would the root access allow somehow to connect other bluetooth devices different than LG? Thanks!
You can do pretty much anything to the system with root, even include support for unsupported devices in form of additional kernel modules.
For example, I've added Samba support so I can mount use my NAS (see my blog at ddscentral dot org for details).
Hey guys is it possible to install android apps into WebOS? I just bought an Lg oled LG 55EG9A7V i want to use Perfect Player IPTV but i cant install it right now...Other then that i dont need anything else..
Can anyone help me?

TWRP question

i am trying to build twrp for a device and i get this
[ 76% 10/13] ----- Making recovery ramdisk ------
FAILED: /home/wajdi/Documents/omni/out/target/product/wingray/ramdisk-recovery.cpio
/bin/bash -c "(mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery ) && (mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/etc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/sdcard /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/tmp ) && (echo Copying baseline ramdisk... ) && (rsync -a --exclude=etc --exclude=sdcard --exclude=vendor --exclude=/root/sepolicy --exclude=/root/plat_file_contexts --exclude=/root/nonplat_file_contexts --exclude=/root/plat_property_contexts --exclude=/root/nonplat_property_contexts --exclude=cache /home/wajdi/Documents/omni/out/target/product/wingray/root /home/wajdi/Documents/omni/out/target/product/wingray/recovery ) && (cp -f /home/wajdi/Documents/omni/out/target/product/wingray/system/bin/adbd /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/sbin/adbd ) && (echo Modifying ramdisk contents... ) && (rm -f /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/init*.rc ) && (cp -f bootable/recovery/etc/init.rc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/ ) && (cp /home/wajdi/Documents/omni/out/target/product/wingray/root/init.recovery.*.rc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/ || true ) && (mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res ) && (rm -rf /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/* ) && (cp -rf bootable/recovery/res-xhdpi/* /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res ) && (cp -f bootable/recovery/fonts/12x22.png /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/images/font.png ) && (cp -rf device/moto/wingray/recovery/root /home/wajdi/Documents/omni/out/target/product/wingray/recovery/ ) && (cp -f device/moto/wingray/twrp.fstab /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/etc/recovery.fstab ) && (cp /home/wajdi/Documents/omni/out/target/product/wingray/obj/PACKAGING/ota_keys_intermediates/keys /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/keys ) && (cat /home/wajdi/Documents/omni/out/target/product/wingray/root/default.prop > /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/prop.default ) && (cat /home/wajdi/Documents/omni/out/target/product/wingray/obj/ETC/system_build_prop_intermediates/build.prop >> /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/prop.default ) && (ln -sf prop.default /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/default.prop ) && (echo "----- Making uncompressed recovery ramdisk ------" ) && (/home/wajdi/Documents/omni/out/host/linux-x86/bin/mkbootfs /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root > /home/wajdi/Documents/omni/out/target/product/wingray/ramdisk-recovery.cpio )"
Copying baseline ramdisk...
cp: cannot stat '/home/wajdi/Documents/omni/out/target/product/wingray/system/bin/adbd': No such file or directory
ninja: build stopped: subcommand failed.
17:08:13 ninja failed with: exit status 1
#### failed to build some targets (48 seconds) ####
ive spent a week searching for a solution and i didnt find anything
Wajdi Muhtadi said:
i am trying to build twrp for a device and i get this
[ 76% 10/13] ----- Making recovery ramdisk ------
FAILED: /home/wajdi/Documents/omni/out/target/product/wingray/ramdisk-recovery.cpio
/bin/bash -c "(mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery ) && (mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/etc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/sdcard /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/tmp ) && (echo Copying baseline ramdisk... ) && (rsync -a --exclude=etc --exclude=sdcard --exclude=vendor --exclude=/root/sepolicy --exclude=/root/plat_file_contexts --exclude=/root/nonplat_file_contexts --exclude=/root/plat_property_contexts --exclude=/root/nonplat_property_contexts --exclude=cache /home/wajdi/Documents/omni/out/target/product/wingray/root /home/wajdi/Documents/omni/out/target/product/wingray/recovery ) && (cp -f /home/wajdi/Documents/omni/out/target/product/wingray/system/bin/adbd /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/sbin/adbd ) && (echo Modifying ramdisk contents... ) && (rm -f /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/init*.rc ) && (cp -f bootable/recovery/etc/init.rc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/ ) && (cp /home/wajdi/Documents/omni/out/target/product/wingray/root/init.recovery.*.rc /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/ || true ) && (mkdir -p /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res ) && (rm -rf /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/* ) && (cp -rf bootable/recovery/res-xhdpi/* /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res ) && (cp -f bootable/recovery/fonts/12x22.png /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/images/font.png ) && (cp -rf device/moto/wingray/recovery/root /home/wajdi/Documents/omni/out/target/product/wingray/recovery/ ) && (cp -f device/moto/wingray/twrp.fstab /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/etc/recovery.fstab ) && (cp /home/wajdi/Documents/omni/out/target/product/wingray/obj/PACKAGING/ota_keys_intermediates/keys /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/res/keys ) && (cat /home/wajdi/Documents/omni/out/target/product/wingray/root/default.prop > /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/prop.default ) && (cat /home/wajdi/Documents/omni/out/target/product/wingray/obj/ETC/system_build_prop_intermediates/build.prop >> /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/prop.default ) && (ln -sf prop.default /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root/default.prop ) && (echo "----- Making uncompressed recovery ramdisk ------" ) && (/home/wajdi/Documents/omni/out/host/linux-x86/bin/mkbootfs /home/wajdi/Documents/omni/out/target/product/wingray/recovery/root > /home/wajdi/Documents/omni/out/target/product/wingray/ramdisk-recovery.cpio )"
Copying baseline ramdisk...
cp: cannot stat '/home/wajdi/Documents/omni/out/target/product/wingray/system/bin/adbd': No such file or directory
ninja: build stopped: subcommand failed.
17:08:13 ninja failed with: exit status 1
#### failed to build some targets (48 seconds) ####
ive spent a week searching for a solution and i didnt find anything
Click to expand...
Click to collapse
It seems that omni project has remove TWRP from their manifest.xml so the source code of boot/recovery folder is from AOSP, not TWRP.
I have the same problem and I solve it by using minimal-manifest-twrp/platform_manifest_twrp_omni on github and I success.
don't forget to use `export ALLOW_MISSING_DEPENDENCIES=true` command before u compile by using minimal-manifest-twrp/platform_manifest_twrp_omni project

Categories

Resources